/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package binary_tree_traverse;

import java.util.Queue;
import java.util.LinkedList;

/**
 *
 * @author sameldin
 */
public class SameTreeTraverse
{
    public SameTreeTraverse()
    {
        
    }
    //==========================================================
    //==========================================================
    public static void preorder(SamNode n)
    {  
        if (n != null)
        {
            System.out.print(n.node_ID + " ");
            preorder(n.getLeft());
            preorder(n.getRight());
        }
    }
    //==========================================================
    //==========================================================
    public static void inorder(SamNode n)
    {
        if (n != null)
        {
            inorder(n.getLeft());
            System.out.print(n.node_ID + " ");
            inorder(n.getRight());
        }
    }
    //==========================================================
    //==========================================================
    public static void postorder(SamNode n)
    {
        if (n != null)
        {
            postorder(n.getLeft());
            postorder(n.getRight());
            System.out.print(n.node_ID + " ");
        }
    }
    //==========================================================
    //==========================================================
    public static void levelorder(SamNode n)
    {
        Queue<SamNode> nodequeue = new LinkedList<SamNode>();

        if (n != null)   
            nodequeue.add(n);
        
        while (!nodequeue.isEmpty())
        {
            SamNode next = nodequeue.remove();
            System.out.print(next.node_ID + " ");
            if (next.getLeft() != null)
            {
                nodequeue.add(next.getLeft());
            }
            if (next.getRight() != null)
            {
                nodequeue.add(next.getRight());
            }
        }
    }
    //==========================================================
    //==========================================================
    public static void main(final String[] args)
    {
        SamNode one = new SamNode(1);
        SamNode two = new SamNode(2);  
        SamNode three = new SamNode(3);
        SamNode four = new SamNode(4);
        SamNode five = new SamNode(5);
        SamNode six = new SamNode(6);
        SamNode seven = new SamNode(7);
        SamNode eight = new SamNode(8);
        SamNode nine = new SamNode(9);
        //======================================
        one.setLeft(two);
        one.setRight(three);
        two.setLeft(four);
        two.setRight(five);  
        three.setLeft(six);
        four.setLeft(seven);
        six.setLeft(eight);
        six.setRight(nine);
        //==============    preorder   ========================
        System.out.println("==============    Start   ========================\n");
        System.out.println("==============    preorder -Left  ========================");
        preorder(one);
        System.out.println();
        //===============   inorder =======================
        System.out.println("==============    inorder   ========================");
        inorder(one);
        System.out.println();
        //===============   postorder   =======================
        System.out.println("==============    postorder - Right  ========================");
        postorder(one);
        System.out.println();
        //===============   levelorder  =======================
        System.out.println("==============    levelorder   ========================");
        levelorder(one);
        System.out.println("\n==============    end   ========================");

    }
}